async function MessageCollector(channelID, options, returnFunction, bot) {
    if (typeof channelID !== "string") throw new Error("Channel ID must be a string");
    if (typeof options !== "object" || typeof options.maxMessages !== "number") throw new Error("Options must be an object");
    if (typeof returnFunction !== "function") throw new Error("The returnFunction must be a function");
    if (!bot) throw new Error("The client is required for this to work");

    let messagesCollected = [];
    let amountOfMessages = 0;
    let finalMessages = options.maxMessages;
    bot.on("messageCreate", function onMessage(msg) {
        if (msg.channel.id === channelID) {
            if(options.userID !== undefined && msg.author.id === options.userID) {
                if (amountOfMessages < options.maxMessages) {
                    returnFunction(msg);
                    messagesCollected.push(msg);
                    amountOfMessages++;
                }
            }

            if(options.userID === undefined) {
                if (amountOfMessages < options.maxMessages) {
                    returnFunction(msg);
                    messagesCollected.push(msg);
                    amountOfMessages++;
                }
            } 
            if (finalMessages === amountOfMessages) {
                bot.removeEventListener("messageCreate", onMessage);
                finished = true;
                return;
            }
        }
    });
}

module.exports = MessageCollector;